;r3getzzz.sc, a paradox crash & burn analysis tool from r3 Software

;4 procs:
;         gather.zzz.u : collects info about all the .zzz files in the current dir
;            get.zzz.u : does the dirty work
;        zzz.browser.u : let's you survey the damage
;  create.zzz.tables.u : builds the control tables

;gather.zzz will gather, analyze, then zip up the zzz files in the current
; directory.
;get.zzz.u reads pdoxinfo.zzz files and generates a report listing
; the conditions that caused the writezzz call.  if a script is involved,
; its diagnostics are included.  
;also, two tables get populated:  zcrash and zburn.  zburn is a keyed
; copy of zcrash.  these two tables contain any unexpected conditions, etc.,
; found in the zzz files.
;getzzz will read any file with the .zzz extension.  i use this to collect
; the files from different workstations into one directory, changing the
; pdoxinfo.zzz filename to a name indicative of the workstation

;copyright (c) 1994,1995 skip rowland/r3 Software Publishing & Consulting, Inc.
;given to the public domain as long as accompanied by this header.
;not for resale or inclusion in any commercial product without prior
; written permission of the author.
;
; skip rowland/r3 Software Publishing & Consulting, Inc.
; 13707 buck rub dr 
; richmond, va  23112 
; 804-739-7474
; cid 75260,2107

;suggestions and comments are greatly encouraged!!!  

PROC gather.zzz.u ()
  PRIVATE
    zzz,
    e,
    bag.s
    
  ECHO OFF
  IF NOT ISTABLE ("zcrash") OR NOT ISTABLE ("zburn") THEN
    create.zzz.tables.u ()
  ENDIF
  
  IF ISFILE ("zzzbomb.sc") THEN
    EDITOR NEW "zzzbomb.sc" MENU {Cancel} {Yes}
  ENDIF
  IF ISFILE ("zzzbomb2.sc") THEN
    EDITOR NEW "zzzbomb2.sc" MENU {Cancel} {Yes}
  ENDIF
  
  MENU "TIIF" SELECT "*.zzz"
  IF NRECORDS ("List") = 0 THEN
    MESSAGE "Sorry, but no .zzz files found in the current dir...Press any key"
    g = GETCHAR ()
    ECHO OFF
    DELETE "list"
    RETURN
  ENDIF
  
  DYNARRAY zzz []
  SCAN
    zzz [[Name]] = [Name]
  ENDSCAN
  DELETE "List"
  
  FOREACH e IN zzz
    get.zzz.u (e)
  ENDFOREACH 
  
  EMPTY "zcrash"
  SAVETABLES
  
  MENU "TEIAA" {zzzbomb2.sc} {zcrash}
  ADD "zcrash" "zburn"  
  IF ISTABLE ("changed") THEN
    DELETE "changed"
  ENDIF
  
  CLEARALL

  ctr.s = 1
  WHILE ISFILE ("zzzbag" + STRVAL (ctr.s) + ".zip") 
    ctr.s = ctr.s + 1
  ENDWHILE
  
  zip.e = "zzzbag" + STRVAL (ctr.s) + " " + "*.zzz"
    
  RUN NOREFRESH "pkzip -a " + zip.e
  RUN NOREFRESH "del *.zzz"
  
ENDPROC  


PROC get.zzz.u (file.a)
; file.a is the name of a .zzz file
  PRIVATE
    stamp.a,
    wa,
    ct,
    bar.a,
    script.death.a,
    dump.a,
    m,
    toss.a
    
    
  EDITOR OPEN file.a  
  MENU "OWC"
  CTRLPGUP

  stamp.a = STRVAL (TODAY ()) + " " + TIME ()
  WINDOW GETATTRIBUTES GETWINDOW () TO wa
  
  PRINT FILE "zzzbomb.sc" FILL ("*", 60), "\n\n"
  PRINT FILE "zzzbomb.sc" "        File: " + wa ["TITLE"] + "\n"
  PRINT FILE "zzzbomb.sc" "       Stamp: " + stamp.a + "\n\n"
  
  ct = 0
  WHILE TRUE
    EDITOR FIND "Paradox Dump:"
    IF NOT RETVAL THEN
      QUITLOOP
    ENDIF
    
    ct = ct + 1
    MESSAGE wa ["TITLE"], " ", ct
    
    HOME
    UP
    UP
    UP
    
    SHIFTPRESS "RIGHT"
    EDITOR EXTRACT TO bar.a
    IF bar.a = "" THEN
      WHILE TRUE
        HOME
        UP
        SHIFTPRESS "RIGHT"
        EDITOR EXTRACT TO bar.a
        IF bar.a <> "" THEN 
          UP
          UP
          HOME
          SHIFTPRESS "END"
          EDITOR EXTRACT TO script.death.a
          PRINT FILE "zzzbomb.sc" "\t", script.death.a, "\n\n"
          QUITLOOP
        ENDIF
      ENDWHILE
    ENDIF
    EDITOR FIND "Paradox Dump:"
      
    END
    DOWN
    DOWN
    HOME
    SHIFTPRESS "END"
    EDITOR EXTRACT TO dump.a
    PRINT FILE "zzzbomb.sc" dump.a, "\n"
    IF SEARCH ("Unexpected", dump.a) = 1 THEN
      m = MATCH (dump.a, "..: .. -..", toss.a, dump.a, toss.a)
      IF NOT m THEN
        m = MATCH (dump.a, "..: ..", toss.a, dump.a)
        IF NOT m THEN
          LOOP
        ENDIF
      ENDIF
      PRINT FILE "zzzbomb2.sc" dump.a, "\n"    
    ENDIF  
  ENDWHILE
  SAVETABLES
  
  EDITOR OPEN "zzzbomb.sc"
  EDITOR FIND stamp.a
  END
  ENTER
  EDITOR INSERT "Bomb Counter: " + STRVAL (ct)
  ENTER 
  DO_IT!
  
  DO_IT!  
  
ENDPROC


PROC zzz.browser.u ()

  ECHO OFF
  VIEW "zburn"
  ECHO NORMAL
  
  WAIT TABLE EXIT TRIGGER "DONE" ENDWAIT
  
  ECHO OFF
  CLEARIMAGE
  
ENDPROC


PROC create.zzz.tables.u ()

  CREATE "zcrash"
    "Failure" : "A55"
    
  CREATE "zburn"
    "Failure" : "A55*"
   
  DELETE "Struct"
  
ENDPROC


gather.zzz.u ()